﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using Sandbox.Common;
using Sandbox.Common.Components;
using Sandbox.Common.ObjectBuilders;
using Sandbox.Definitions;
using Sandbox.ModAPI;
using Sandbox.ModAPI.Interfaces;
using Sandbox.Game.Entities;
using Sandbox.Game.Gui;
using Sandbox.Game;
using VRage.Common.Utils;
using VRageMath;
using VRage;
using VRage.ObjectBuilders;
using VRage.Components;
using VRage.ModAPI;
using VRage.Utils;
using VRage.Library.Utils;

using Ingame = Sandbox.ModAPI.Ingame;

namespace Comfyfutons.AtmosphericDrag
{
    [MySessionComponentDescriptor(MyUpdateOrder.AfterSimulation)]
    public class AtmospereDetection : MySessionComponentBase
    {
        public static Dictionary<long, MyPlanet> planets = new Dictionary<long, MyPlanet>();
        public static List<long> removePlanets = new List<long>();
        private int skip = 0;
        private const int SKIP_TICKS = 60*3;
        
        private static HashSet<IMyEntity> ents = new HashSet<IMyEntity>(); // this is always empty
        
        public override void UpdateAfterSimulation()
        {
            if(++skip >= SKIP_TICKS)
            {
                skip = 0;
                MyAPIGateway.Entities.GetEntities(ents, 
                                                    delegate(IMyEntity e)
                                                    {
                                                        if(e is MyPlanet)
                                                        {
                                                            if (!AtmospereDetection.planets.ContainsKey(e.EntityId))
                                                                AtmospereDetection.planets.Add(e.EntityId, e as MyPlanet);
                                                        }
                                                      
                                                        return false; // no reason to add to the list
                                                    }
                                                 );
                
            }
        }
        
        protected override void UnloadData()
        {
            planets.Clear();
            removePlanets.Clear();
            ents.Clear();
        }
    }
}